SystemOrganization addCategory: #SWA014!

CircleMorph subclass: #SWA014Food
	instanceVariableNames: 'bodysize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Food class methodsFor: 'as yet unclassified' stamp: 'MV 12/9/2016 11:34'!
newWithSize: aSize		
	^self new
		bodysize: aSize;
		extent: aSize asPoint;
		color: Color yellow;
		yourself.
		! !

!SWA014Food methodsFor: 'accessing' stamp: 'MV 12/9/2016 11:06'!
bodysize 
	^bodysize.! !

!SWA014Food methodsFor: 'accessing' stamp: 'MV 12/9/2016 11:06'!
bodysize: aSize
	bodysize := aSize.! !

CircleMorph subclass: #SWA014LivingThing
	instanceVariableNames: 'bodysize speed id direction world currentStep maxAllowedSize minAllowedSize minAllowedSpeed maxAllowedSpeed realPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014LivingThing commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein sich aktiv bewegendes am Spiel teilnehmendes Object.!

SWA014LivingThing subclass: #SWA014Enemy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Enemy commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein Konkurrent im Spiel.!

!SWA014Enemy methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:39'!
bigNumber
	^SmallInteger maxVal.! !

!SWA014Enemy methodsFor: 'movement' stamp: 'MV 12/21/2016 18:19'!
"Enemys should follow the nearest object, which could be eaten by them. Also they should run away, if there is a bigger LivingThing (Player or Enemy) nearby."

calculateMovement: target
	super calculateMovement: target realPosition.
	
	target bodysize >= self bodysize
	ifTrue: [	self direction: 0.0 asPoint - self direction].
	! !

!SWA014Enemy methodsFor: 'vision' stamp: 'MV 12/21/2016 18:22'!
nearestEnemy
	|smallestDistance nearestEnemyobject allEnemies currentDistance|
	
	smallestDistance := self bigNumber.
	nearestEnemyobject := self.
	
	allEnemies := Set new.
	allEnemies := self swaworld listOfEnemies copy.
	allEnemies add: self swaworld swaplayer.
	
	allEnemies do: [:enemy| 
		currentDistance := self distanceTo: (enemy realPosition).
		currentDistance  < smallestDistance ifTrue: [
			smallestDistance := currentDistance.
			nearestEnemyobject := enemy]]
	without: self.

	^nearestEnemyobject.! !

!SWA014Enemy methodsFor: 'override' stamp: 'MV 12/21/2016 18:16'!
step
	"self currentStep > self stepNumber
		ifTrue: ["
			self 
				calculateMovement: self nearestEnemy;
				moveAutomatically;
				currentStep: 0;
				yourself"] 
		ifFalse: [self currentStep: self currentStep + 1]".
	
	super step.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/30/2016 22:59'!
bodysize 
	^bodysize.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 12/16/2016 12:09'!
bodysize: x
	x < (self maxAllowedSize)
		ifTrue: [
			x > (self minAllowedSize) 
				ifTrue: [	bodysize := x]
				ifFalse: [bodysize := self minAllowedSize]]
		ifFalse: [bodysize := self maxAllowedSize].
	! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 12/20/2016 20:38'!
calculateMovement: target
	|directionVector deltaX deltaY distance|
		
	deltaX := target x - self realPosition x.
	deltaY := target y - self realPosition y.
	
	distance := ((deltaX raisedTo: 2) +
	 			(deltaY raisedTo: 2)) sqrt.
	distance = 0 ifTrue: [distance := 1.]. "prevent us from dividing by zero"
	
	directionVector := (deltaX/distance)@(deltaY/distance).
	
	self direction: directionVector.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 12/20/2016 20:36'!
checkForCollisions
	|radius listOfLivingThings|
	self flag: 'Eventuell sollten Foodcollisions von normalen getrennt werden. Diese Methode ist zu lang'.
	
	radius := self bodysize/2.
	radius := radius raisedTo: 2.	
	listOfLivingThings := Set new.
	listOfLivingThings := self swaworld listOfEnemies copy.
	listOfLivingThings add: self swaworld swaplayer.
	
	listOfLivingThings do: [:enemy|
		(enemy ~~ self) ifTrue: [
			((self == self swaworld swaplayer) and: (self checkForOverlapWith: enemy)) ifTrue: [
				(enemy bodysize < self bodysize)
				ifTrue: [enemy borderColor: Color green] 
				ifFalse: [enemy borderColor: Color red]].
			
			(enemy bodysize < self bodysize) ifTrue: [					
				((self distanceTo: enemy realPosition) < radius) ifTrue: [
					self eat: enemy]]]].

	self swaworld listOfFood do: [:eatable|
		((self distanceTo: eatable center) < radius) ifTrue: [
			self eat: eatable]].! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 12/10/2016 14:04'!
checkForOverlapWith: enemy
	^(self bottom > enemy top and: 
	    self top < enemy bottom and:
	    self left < enemy right and:
	    self right > enemy left).
! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/24/2016 20:53'!
currentStep
	^currentStep.! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/24/2016 20:52'!
currentStep: x
	currentStep := x.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/11/2016 14:45'!
direction
	^direction.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/11/2016 14:44'!
direction: x
	direction := x.! !

!SWA014LivingThing methodsFor: 'vision' stamp: 'MV 12/20/2016 20:33'!
distanceTo: enemy
	^((enemy x - self realPosition x) raisedTo: 2) +
	 ((enemy y - self realPosition y) raisedTo: 2). "Pythagoras' theorem"! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 12/16/2016 12:20'!
eat: prey
	self bodysize: 2* (((self bodysize / 2) raisedTo: 2) + ((prey bodysize / 2) raisedTo: 2)) sqrt.

	self swaworld listOfEnemies: 
		(self swaworld listOfEnemies reject: [:enemy| enemy == prey]).
	self swaworld listOfFood:
		(self swaworld listOfFood reject: [:eatable| eatable == prey]).
		
	(prey ~~ self swaworld swaplayer) 
		ifTrue: [	prey delete]
		ifFalse: [self swaworld game gameOver].! !

!SWA014LivingThing methodsFor: 'initialization' stamp: 'MV 12/16/2016 15:53'!
initialize
	super initialize.
	
	self 
		maxAllowedSize: 1000;
		maxAllowedSpeed: 1000;
		minAllowedSize: 10;
		minAllowedSpeed: 1;
		currentStep: 0;
		speed: 60;
		direction: 0@0;
		borderWidth: 2;
		yourself.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:35'!
maxAllowedSize
	^maxAllowedSize.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:32'!
maxAllowedSize: aNumber
	maxAllowedSize := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:35'!
maxAllowedSpeed
	^maxAllowedSpeed.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:12'!
maxAllowedSpeed: aNumber
	maxAllowedSpeed := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:35'!
minAllowedSize
	^minAllowedSize.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:33'!
minAllowedSize: aNumber
	minAllowedSize := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:36'!
minAllowedSpeed
	^minAllowedSpeed.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:13'!
minAllowedSpeed: aNumber
	minAllowedSpeed := aNumber.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 12/20/2016 20:32'!
moveAutomatically
	self realPosition: self realPosition + (self direction).
	self center: self realPosition + self swaworld realPosition.! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'MV 12/20/2016 20:20'!
realPosition
	^realPosition.! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'MV 12/20/2016 20:20'!
realPosition: aPoint
	realPosition := aPoint.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/30/2016 23:17'!
refreshSize
	self extent: self bodysize asPoint.
	
	! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/4/2016 12:37'!
speed
	^speed.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 12/16/2016 15:48'!
speed: x
	x < self maxAllowedSpeed 
		ifTrue: [
			x> (self minAllowedSpeed) 
			ifTrue: [speed := x]
			ifFalse: [speed := self minAllowedSpeed]]
		ifFalse: [speed := self maxAllowedSpeed].
	! !

!SWA014LivingThing methodsFor: 'override' stamp: 'MV 12/16/2016 12:24'!
step
	self 
		checkForCollisions;
		refreshSize;
		yourself.! !

!SWA014LivingThing methodsFor: 'override' stamp: 'MV 12/16/2016 12:28'!
stepNumber
	"This is used to keep the stepTime up to date"
	self flag: 'Der Teil mit maxVal funktioniert nicht so wie geplant. Gegebenenfalls den Fall speed=0 überdenken'.
	
	^self speed ~= 0
	   	ifTrue: [	10 * self bodysize / self speed]
		ifFalse: [SmallInteger maxVal. "Stops stepping"].
	! !

!SWA014LivingThing methodsFor: 'override' stamp: 'MV 12/6/2016 10:16'!
stepTime
	^100! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:12'!
swaworld
	^world.! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:12'!
swaworld: x
	world := x.! !

SWA014LivingThing subclass: #SWA014Player
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Player commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Der Spieler.!

!SWA014Player methodsFor: 'movement' stamp: 'MV 12/20/2016 20:30'!
moveAutomatically
	self swaworld realPosition: self swaworld realPosition - (self direction * 2).
	self swaworld position: self swaworld realPosition.
	self realPosition: self realPosition + (self direction * 2).
	self center: self realPosition + self swaworld realPosition.
! !

!SWA014Player methodsFor: 'as yet unclassified' stamp: 'M.V. 11/4/2016 12:42'!
number
	^number.! !

!SWA014Player methodsFor: 'as yet unclassified' stamp: 'M.V. 11/4/2016 12:41'!
number: x
	number := x.! !

!SWA014Player methodsFor: 'override' stamp: 'MV 12/20/2016 20:30'!
step
	super step.
	
	self calculateMovement: World activeHand center - (((World bounds width)@(World bounds height)) / 2.0) + self realPosition.
	self 
		moveAutomatically;
		yourself.! !

Morph subclass: #SWA014Game
	instanceVariableNames: 'world maxSize numberOfEnemies foodSize amountOfFood'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Game commentStamp: 'M.V. 11/11/2016 11:51' prior: 0!
Hält instanzen von World fest.!

!SWA014Game class methodsFor: 'as yet unclassified' stamp: 'MV 12/9/2016 11:36'!
open
	^self new spawnPlayer; spawnEnemy; spawnFood; openInWorld; yourself.
	! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 12:02'!
amountOfFood
	^amountOfFood.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 12:02'!
amountOfFood: anAmount
	amountOfFood := anAmount.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 11:55'!
foodSize
	^foodSize.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 11:55'!
foodSize: aSize
	foodSize := aSize.! !

!SWA014Game methodsFor: 'game events' stamp: 'MV 12/16/2016 11:35'!
gameOver
	self delete.! !

!SWA014Game methodsFor: 'initialization' stamp: 'MV 12/21/2016 18:32'!
initialize
	super initialize.

	self 
		extent: ActiveWorld extent;
		clipSubmorphs: true;
		swaworld: SWA014World new;
		addMorph: self swaworld;
		maxSize: 75;
		foodSize: 10;
		numberOfEnemies: 100;
		amountOfFood: 1000;
		yourself.
		
	self swaworld game: self.
	self swaworld position: self position.
	self swaworld realPosition: self position.
! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 12:02'!
maxSize
	^maxSize.
	! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 11:50'!
maxSize: aSize
	maxSize := aSize.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 12:03'!
numberOfEnemies
	^numberOfEnemies.! !

!SWA014Game methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:25'!
numberOfEnemies: aNumber
	numberOfEnemies := aNumber.! !

!SWA014Game methodsFor: 'spawning' stamp: 'MV 12/21/2016 18:25'!
spawnEnemy
"spawns SWA014Enemys up to the specified number"
	|enemy random r1 r2 r3|

	1 to: (self numberOfEnemies)  do: [:x|	
		enemy := SWA014Enemy new.
		random := Random new.
		r1 := random nextInt: self swaworld width.
		r2 := random nextInt: self swaworld height.
		r3 := random nextInt: (self maxSize).
		enemy realPosition: (r1@r2).
		enemy bodysize: r3.	
		enemy swaworld: self swaworld.
		self swaworld listOfEnemies add: enemy.
		self swaworld addMorph: enemy].! !

!SWA014Game methodsFor: 'spawning' stamp: 'MV 12/16/2016 12:05'!
spawnFood
	|eatable random r1 r2|

	self flag: 'Diese Methode ist extrem ähnlich zu spawnEnemy. Wie sollten das irgendwie zusammenfassen'.
		
	1 to: (self amountOfFood)  do: [:x|	
		eatable := SWA014Food newWithSize: self foodSize.
		random := Random new.
		r1 := random nextInt: self swaworld width.
		r2 := random nextInt: self swaworld height.
		eatable center: (r1 + self swaworld left @ r2 + self swaworld top).
		self swaworld listOfFood add: eatable.
		self swaworld addMorph: eatable].! !

!SWA014Game methodsFor: 'spawning' stamp: 'MV 12/20/2016 20:43'!
"An importent disigndicision is, that the player isn't added to the world but to the game instead. This removes redundant code to hold the player in the center of the world, stops strange things happening cause of rounding errors and there is no more need for workarounds, when colliding with the worldbouns."

spawnPlayer
	|newPlayer|
	newPlayer := SWA014Player new.
	newPlayer color: Color red.
	newPlayer bodysize: 60.
	newPlayer realPosition:  ((World bounds width / 2 + 0.001)@(World bounds height / 2 + 0.001)).
	newPlayer swaworld: self swaworld.		
	self swaworld swaplayer: newPlayer.
	self swaworld addMorph: newPlayer.! !

!SWA014Game methodsFor: 'spawning' stamp: 'Tc 11/11/2016 14:35'!
spawnPowerup
self flag: 'TODO: implement; this is an extension and shouldn''t be implemented until the basic game works'.! !

!SWA014Game methodsFor: 'override' stamp: 'MV 12/21/2016 18:19'!
step
	"self swaworld swaplayer center: self center."
	! !

!SWA014Game methodsFor: 'override' stamp: 'MV 12/6/2016 19:34'!
stepTime
	^1000.! !

!SWA014Game methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:21'!
swaworld
	^world.! !

!SWA014Game methodsFor: 'accessors' stamp: 'Tc 12/4/2016 21:26'!
swaworld: aWorld
	world := aWorld.! !

SimpleButtonMorph subclass: #SWA014EndButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014EndButton methodsFor: 'as yet unclassified' stamp: 'MV 12/16/2016 11:27'!
initialize 
	super initialize.

	self 
		label: 'End Game';
		color: Color yellow;
		center: (World width /2)@(World height /2 + (World height /50));
		yourself.! !

!SWA014EndButton methodsFor: 'as yet unclassified' stamp: 'MV 12/16/2016 11:26'!
mouseDown: evt
	owner delete.! !

SimpleButtonMorph subclass: #SWA014StartButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014StartButton methodsFor: 'as yet unclassified' stamp: 'MV 12/16/2016 11:27'!
initialize 
	super initialize.

	self 
		label: 'Start Game';
		color: Color blue;
		center: (World width /2)@(World height /2 - (World height /50));
		yourself.! !

!SWA014StartButton methodsFor: 'as yet unclassified' stamp: 'MV 12/16/2016 11:33'!
mouseDown: evt
	SWA014Game open.! !

ImageMorph subclass: #SWA014Menu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Menu class methodsFor: 'as yet unclassified' stamp: 'MV 12/16/2016 11:32'!
open
	^SWA014Menu new openInWorld.! !

!SWA014Menu methodsFor: 'initialization' stamp: 'MV 12/16/2016 11:10'!
initialize 
	super initialize.
	
	self 
		newForm: (ImageReadWriter formFromFileNamed: 'Chrysanthemum.jpg');
		addMorph:  SWA014StartButton new;
		addMorph: SWA014EndButton new;
		yourself.! !

ImageMorph subclass: #SWA014World
	instanceVariableNames: 'worldSize listOfEnemies listOfFood swaplayer game realPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014World commentStamp: 'M.V. 11/11/2016 11:52' prior: 0!
Die Welt in der gespielt wird. Sie beinhaltet Feinde und hat eine gewisse Größe.!

!SWA014World methodsFor: 'collisionHandling' stamp: 'MV 12/20/2016 20:28'!
checkForBorderCollisions
	|enemyListWithPlayer|
	
	enemyListWithPlayer:= listOfEnemies copy.
	enemyListWithPlayer add: self swaplayer.
	
	enemyListWithPlayer do: [:enemy | 
		enemy bounds right > self bounds right ifTrue:	[
				enemy realPosition: ((self bounds right - 100.01)@(enemy realPosition y))
			
			].
	
	(enemy bounds left < self bounds left) ifTrue:
	[
		enemy  realPosition: ((self bounds left+100.01)@(enemy realPosition y))
	].

	(enemy bounds top < self bounds top) ifTrue:
	[
		enemy  realPosition: ((enemy realPosition x)@(self bounds top+100.01))
	].
	
	(enemy bounds bottom > self bounds bottom) ifTrue:
	[
		enemy  realPosition: ((enemy realPosition y)@(self bounds bottom-100.01))
	].
	].! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game
	^game.! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game: x
	game := x.! !

!SWA014World methodsFor: 'initialization' stamp: 'MV 12/9/2016 11:41'!
initialize
	|aForm|
	super initialize.
	aForm := ImageReadWriter formFromFileNamed: 'Chrysanthemum.jpg'.
	self newForm: aForm.
	self listOfEnemies: Set new.
	self listOfFood: Set new.
	self swaplayer: nil.
	self worldSize: 3000.
	self extent: self worldSize asPoint.	
	self color: Color transparent.
	self clipSubmorphs: true.
	
	
! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/4/2016 14:37'!
listOfEnemies
	^ listOfEnemies! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/4/2016 14:37'!
listOfEnemies: anObject
	listOfEnemies := anObject! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/9/2016 11:39'!
listOfFood
	^ listOfFood.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/9/2016 11:40'!
listOfFood: anObject
	listOfFood := anObject.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/20/2016 20:19'!
realPosition
	^realPosition.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/20/2016 20:19'!
realPosition: aPoint
	realPosition := aPoint.! !

!SWA014World methodsFor: 'overrideMethod' stamp: 'Tc 12/2/2016 16:02'!
step
	self checkForBorderCollisions.! !

!SWA014World methodsFor: 'overrideMethod' stamp: 'Tc 12/2/2016 16:02'!
stepTime
	^100! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/30/2016 22:55'!
swaplayer
	^swaplayer.! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/30/2016 22:55'!
swaplayer: x
	swaplayer := x.! !

!SWA014World methodsFor: 'accessing' stamp: 'Tc 11/30/2016 20:31'!
worldSize
	^worldSize! !

!SWA014World methodsFor: 'accessing' stamp: 'Tc 11/30/2016 20:32'!
worldSize: anObject
	worldSize := anObject! !
